import java.applet.Applet;
import java.awt.event.*;
import java.awt.*;
import java.math.*;

/**This is a single variable polynomial*/

public class Poly1 {
    BigRational[] C=new BigRational[50];
    int degree;

    public Poly1() {
	degree=0;
	for(int i=0;i<50;++i) C[i]=new BigRational(0,1);
    }
    
    /** NEW(x) = x OLD(x)*/
    public void shiftUp() {
	++degree;
	for(int i=degree;i>0;--i) {
	    this.C[i]=new BigRational(this.C[i-1]);
	}
	this.C[0]=new BigRational(0,1);
    }

    /**positive dominance test.
       Strong = true means that we test
       (strong) positive dominance.
       Strong = false means that we test
       weak positive dominance.*/

    public boolean isPositiveDominant(boolean strong) {
	BigRational R=new BigRational(0,1);
	for(int i=0;i<=this.degree;++i) {
	    R=R.add(C[i]);
	    if(strong==false) {
	       if(R.isNegative()==true) return false;
	    }
	    if(strong==true) {
	       if(R.isPositive()==false) return false;
	    }
	}
	return true;
    }

    /**printing routines*/
    public void print() {
	System.out.println("-------------------");
	for(int i=0;i<=degree;++i) {
	    C[i].print();
	    System.out.print(" x^"+i);
	    if(i<degree) System.out.println(" + ");
	    if(i==degree) System.out.println("");
	}
	System.out.println("-------------------");
    }


    public void printN() {
	System.out.println("-------------------");
	for(int i=0;i<=degree;++i) {
	    C[i].printN();
	    System.out.print(" x^"+i);
	    if(i<degree) System.out.println(" + ");
	    if(i==degree) System.out.println("");
	}
	System.out.println("-------------------");
    }

}


    

